<?php
/*
Plugin Name: If You Liked That...
Plugin URI: http://www.bochgoch.com/wordpress/2007/06/03/if-you-liked-that-plugin/
Description: Following the content of a post, this plugin inserts links to a user selectable number of other posts in the same category as the main post.
Version: 1.3
Author: bochgoch
Author URI: http://www.bochgoch.com
*/

/*  Copyright 2007  Martin Ford, Bochgoch Limited  (email : wordpress@bochgoch.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
add_option('ifyoulikedthat_numberOfPosts', '5', 'The number of links to related posts generated by the If You Liked That plugin', 'yes');
add_option('ifyoulikedthat_orderBy', 'rand()', 'The selection method for the related posts generated by the If You Liked That plugin', 'yes');
add_option('ifyoulikedthat_showAuthor', 'Y', 'Flag to select if the post author will be shown after the link by the If You Liked That plugin', 'yes');
add_option('ifyoulikedthat_showDate', 'Y', 'Flag to select if the post date will be shown after the link by the If You Liked That plugin', 'yes');
add_option('ifyoulikedthat_showSentence', 'Y', 'Flag to select if a sentence of the post will be shown after the link by the If You Liked That plugin', 'yes');
add_option('ifyoulikedthat_showHeading', 'If you liked that post, then try these...', 'Heading shown above the If You Liked That plugin links', 'yes');
add_option('ifyoulikedthat_excludeCategories', '', 'A comma separated list of categories for which linked posts will not be displayed (leave blank for no exlusions)', 'yes');
add_option('ifyoulikedthat_singleOnly', 'N', 'Flag to select if links are only posted on single post pages', 'yes');
add_option('ifyoulikedthat_position', 'embed', 'Flag to select where the links are positioned in relation to the post', 'yes');
add_option('ifyoulikedthat_embedAfter', '<!--IYLT HERE-->', 'A positioning option ~ the IYLT links will be placed after this HTML if the embed option has been selected', 'yes');

function if_you_liked_that_o() {
	global $g_ifYouLikedThatHTML;
	echo $g_ifYouLikedThatHTML;
}

function if_you_liked_that($content) {
	global $wpdb;
	global $post;
	global $g_ifYouLikedThatHTML;
	  
	$cat = get_the_category();  
	$cat = $cat[0];
  $INcat = $cat->cat_ID;
  if ( strlen($INcat) == 0 ) { $INcat = '0'; }

	$numPosts = get_option('ifyoulikedthat_numberOfPosts');
	$orderBy = get_option('ifyoulikedthat_orderBy');
	$showSentence = get_option('ifyoulikedthat_showSentence');
	$showAuthor = get_option('ifyoulikedthat_showAuthor');
	$showDate = get_option('ifyoulikedthat_showDate');
	$Heading = get_option('ifyoulikedthat_showHeading');
	$excludeCategories = get_option('ifyoulikedthat_excludeCategories');
	if (strlen($excludeCategories) == 0) {$excludeCategories = '-9999';}
	$singleOnly = get_option('ifyoulikedthat_singleOnly');
	$position = get_option('ifyoulikedthat_position');
	$positionHTML = stripslashes(html_entity_decode(get_option('ifyoulikedthat_embedAfter')));
	if ($position == 'widget') { $positionHTML = '123 not in this post xyz'; } // over write the positioning HTML 
	
	if ($post->post_type == 'page') {return $content;} // exclude on pages
	if (!is_single() and $singleOnly == 'Y') {return $content;} // include only on single view

	$version = explode(".", get_bloginfo('version'));
	if ( $version[0] > 2 or ($version[0] == 2 and $version[1] >= 3) ) // version greater than 2.3
	{
	 $ifYouLikedThats = $wpdb->get_results("SELECT t1.ID, t1.post_title, t1.post_date, t1.post_content, t3.display_name FROM $wpdb->posts t1, $wpdb->term_taxonomy t2, $wpdb->term_relationships t4, $wpdb->users t3 WHERE t1.post_status = 'publish' AND t1.ID != ".$post->ID." AND t1.ID=t4.object_id AND t4.term_taxonomy_id = t2.term_taxonomy_id AND t2.taxonomy = 'category' AND t2.term_taxonomy_id IN (".$INcat.") AND t2.term_taxonomy_id NOT IN (".$excludeCategories.") AND t1.post_author = t3.ID ORDER BY ".$orderBy." LIMIT ".$numPosts);
	}
	else // pre 2.3
	{
	 $ifYouLikedThats = $wpdb->get_results("SELECT t1.ID, t1.post_title, t1.post_date, t1.post_content, t3.display_name FROM $wpdb->posts t1, $wpdb->post2cat t2, $wpdb->users t3 WHERE t1.ID=t2.post_id AND t1.post_status = 'publish' AND t1.ID != ".$post->ID." AND t2.category_id IN (".$INcat.") AND t2.category_id NOT IN (".$excludeCategories.") AND t1.post_author = t3.ID ORDER BY ".$orderBy." LIMIT ".$numPosts);
	}
  
	if (count($ifYouLikedThats) > 0) {
  	$ifYouLikedThatsHTML = '<div id="ifyoulikedthat"><h3>'.$Heading.'</h3>';
    foreach ($ifYouLikedThats as $ifYouLikedThat) {
			$postSentence = '';
  	  if (substr(strtolower($showSentence),0,1) == 'y') {
  			$pieces = split("\. ?", $ifYouLikedThat->post_content);
    		if (strlen($pieces[0]) > 0) {
  				$postSentence = '<br />'.strip_tags($pieces[0]).'.';
  			} 
			}
    	$ifYouLikedThatsHTML .= '<p><a href="'.get_permalink($ifYouLikedThat->ID).'">'.$ifYouLikedThat->post_title.'</a>';
			if (substr(strtolower($showAuthor),0,1) == 'y') { $ifYouLikedThatsHTML .= ' by '.$ifYouLikedThat->display_name; }
			if (substr(strtolower($showDate),0,1) == 'y') { $ifYouLikedThatsHTML .= ' on '.date('F jS, Y',strtotime($ifYouLikedThat->post_date)); }
			$ifYouLikedThatsHTML .= $postSentence.'</p>';
    }
    $ifYouLikedThatsHTML .= '</div>';
	}	else {
    $ifYouLikedThatsHTML = '';
	}
	$g_ifYouLikedThatHTML = $ifYouLikedThatsHTML; // use this for global (prior to addition of content)

	if ($position == 'before')
	{	$ifYouLikedThatsHTML = $ifYouLikedThatsHTML.$content; }
	elseif ($position == 'after')
	{	$ifYouLikedThatsHTML = $content.$ifYouLikedThatsHTML; }
	else // embed
	{
	 $stringPosition = strpos($content, $positionHTML);
	 if ( $stringPosition === false ) // string not found
	 {	
	 	$ifYouLikedThatsHTML = $content; // don't display IYLT links
	 }
	 else // found
	 {
	 	$ifYouLikedThatsHTML = substr($content, 0, $stringPosition) . 
												 	 				$positionHTML . 
																	$ifYouLikedThatsHTML . 
																	substr($content, $stringPosition + strlen($positionHTML), strlen($content) - $stringPosition);
	 }
	} 
  return $ifYouLikedThatsHTML;
}
// execute main function on execution of the_content
add_action('the_content', 'if_you_liked_that');

function if_you_liked_that_css() {
	echo "
	<style type='text/css'>
	#ifyoulikedthat {
	margin: 0 0 2em 0; 
	padding: 0;
	}
  #ifyoulikedthat p
	{
	margin:0; 
	padding: 0;
	font-size: 0.8em;
	}
  #ifyoulikedthat p a
	{
	margin:0; 
	padding: 0;
	font-size: 1em;
	font-weight: 900;
	}
	</style>
	";
}
//poke the css into the <head>
add_action('wp_head', 'if_you_liked_that_css');

function iylt_plugin_menu() {
  $message = null;
  $message_updated = __("If You Liked That Options Updated.");
  
  // update options
  if ($_POST['action'] && $_POST['action'] == 'iylt_update') {
  	$message = $message_updated;
  
  	update_option('ifyoulikedthat_numberOfPosts', $_POST['ifyoulikedthat_numberOfPosts']);
  	update_option('ifyoulikedthat_orderBy', $_POST['ifyoulikedthat_orderBy']);
  	update_option('ifyoulikedthat_showAuthor', $_POST['ifyoulikedthat_showAuthor']);	
  	update_option('ifyoulikedthat_showDate', $_POST['ifyoulikedthat_showDate']);	
  	update_option('ifyoulikedthat_showSentence', $_POST['ifyoulikedthat_showSentence']);
  	update_option('ifyoulikedthat_showHeading', $_POST['ifyoulikedthat_showHeading']);
  	update_option('ifyoulikedthat_excludeCategories', $_POST['ifyoulikedthat_excludeCategories']);
  	update_option('ifyoulikedthat_singleOnly', $_POST['ifyoulikedthat_singleOnly']);		
  	update_option('ifyoulikedthat_position', $_POST['ifyoulikedthat_position']);			
  	update_option('ifyoulikedthat_embedAfter', htmlspecialchars($_POST['ifyoulikedthat_embedAfter']));		
					
  	wp_cache_flush();
  }
  if ($message) : ?>
  <div id="message" class="updated fade"><p><?php echo $message; ?></p></div>
  <?php endif; ?>
  <div id="dropmessage" class="updated" style="display:none;"></div>
  <div class="wrap">
  <h2><?php _e('If You Liked That Plugin Options'); ?></h2>
  <p><?php _e('With queries, questions or suggestions <a title="Bochgoch Home for Wordpress Plugins" href="http://www.bochgoch.com/?p=wp">Visit Bochgoch</a>.') ?></p>
  <form name="dofollow" action="" method="post">
  <table>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('The heading to display above the linked posts:')?></td>
  <td>
  <input size="80" name="ifyoulikedthat_showHeading" value="<?php echo stripcslashes(get_option('ifyoulikedthat_showHeading')); ?>"/>
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('The number of post links to display:')?></td>
  <td>
  <input size="2" name="ifyoulikedthat_numberOfPosts" value="<?php echo stripcslashes(get_option('ifyoulikedthat_numberOfPosts')); ?>"/>
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Ordering method for the displayed posts:')?></td>
  <td>
  <input type="radio" name="ifyoulikedthat_orderBy" value="rand()" <?php if (get_option('ifyoulikedthat_orderBy')=='rand()') echo "checked"; ?>> Random<br>
  <input type="radio" name="ifyoulikedthat_orderBy" value="post_date asc" <?php if (get_option('ifyoulikedthat_orderBy')=='post_date asc') echo "checked"; ?>> Date of post - ascending<br>
  <input type="radio" name="ifyoulikedthat_orderBy" value="post_date desc" <?php if (get_option('ifyoulikedthat_orderBy')=='post_date desc') echo "checked"; ?>> Date of post - descending<br>
  <input type="radio" name="ifyoulikedthat_orderBy" value="post_title asc" <?php if (get_option('ifyoulikedthat_orderBy')=='post_title asc') echo "checked"; ?>> Title of post - ascending<br>
  <input type="radio" name="ifyoulikedthat_orderBy" value="post_title desc" <?php if (get_option('ifyoulikedthat_orderBy')=='post_title desc') echo "checked"; ?>> Title of post - descending<br>
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Show the name of the linked post author:')?></th>
  <td>
  <input size="1" name="ifyoulikedthat_showAuthor" value="<?php echo stripcslashes(get_option('ifyoulikedthat_showAuthor')); ?>"/> (Y/N)
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Show the date that the linked post was made:')?></th>
  <td>
  <input size="1" name="ifyoulikedthat_showDate" value="<?php echo stripcslashes(get_option('ifyoulikedthat_showDate')); ?>"/> (Y/N)
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Show the first sentence of linked posts:')?></td>
  <td>
  <input size="1" name="ifyoulikedthat_showSentence" value="<?php echo stripcslashes(get_option('ifyoulikedthat_showSentence')); ?>"/> (Y/N)
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('A comma separated list of categories for which linked posts will not be displayed:')?></td>
  <td>
  <input size="12" name="ifyoulikedthat_excludeCategories" value="<?php echo stripcslashes(get_option('ifyoulikedthat_excludeCategories')); ?>"/>eg. to exclude posts in categories two and eight simply enter: <b>2,8</b>
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Show links only on single post pages:')?></td>
  <td>
  <input size="1" name="ifyoulikedthat_singleOnly" value="<?php echo stripcslashes(get_option('ifyoulikedthat_singleOnly')); ?>"/> (Y/N)
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Positioning of the linked posts:')?></td>
  <td>
  <input type="radio" name="ifyoulikedthat_position" value="widget" <?php if (get_option('ifyoulikedthat_position')=='widget') echo "checked"; ?>> As a widget (ensure that the widget is in a sidebar that will run <i>after</i> <a href="http://codex.wordpress.org/The_Loop">the loop</a>.)<br />
  <input type="radio" name="ifyoulikedthat_position" value="before" <?php if (get_option('ifyoulikedthat_position')=='before') echo "checked"; ?>> Before the post<br />
  <input type="radio" name="ifyoulikedthat_position" value="after" <?php if (get_option('ifyoulikedthat_position')=='after') echo "checked"; ?>> After the post<br />
  <input type="radio" name="ifyoulikedthat_position" value="embed" <?php if (get_option('ifyoulikedthat_position')=='embed') echo "checked"; ?>> Embedded in the post<br />
  </td>
  </tr>
  <tr>
  <th scope="row" style="text-align:right; vertical-align:top;"><?php _e('Embed after <u>this</u> HTML in the post')?></td>
  <td>
  <input size="30" name="ifyoulikedthat_embedAfter" value="<?php echo stripcslashes(get_option('ifyoulikedthat_embedAfter')); ?>"/><br />NB: Only used with <i>Embedded in the post</i> positioning option
  </td>
  </tr>
  </table>
  <p class="submit">
  <input type="hidden" name="action" value="iylt_update" /> 
  <input type="submit" name="Submit" value="<?php _e('Update Options')?> &raquo;" /> 
  </p>
  </form>
  </div>
  <?php
}

function mt_add_pages() {
    add_options_page('If you liked that options', 'If You Liked That', 8, 'if_you_liked_that.php', 'iylt_plugin_menu'); // Add a new menu under Options:
}
add_action('admin_menu', 'mt_add_pages');

// widgetise!
add_action('plugins_loaded', 'iylt_init');
function iylt_init() {
    if (!function_exists('register_sidebar_widget')) { return; }
    register_sidebar_widget('If You Liked That', 'if_you_liked_that_o'); 
}
?>
